//+----------------------------------------------------------------------------+
//| xxxxxxxxxxxxxxxxxxxxxx Standard Class Library xxxxxxxxxxxxxxxxxxxxxxxxxxxx |
//| xxxxxxxxxxxxxxx Konstantin Karpov | coder-ex@yandex.ru xxxxxxxxxxxxxxxxxxx |
//+----------------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

#include <Arrays\List.mqh>
#include <SCL\v4.03\Container\ValType.mqh>

//+----------------------------------------------------------------------------+
/*!
   \brief      ,      -  ,
            FIFO   ( ,  ).

   \details       .
   
   \details   Back  Front   ,     
              ,  GetData  CValContType.     
               ,      .
*/
class CQueue : private CList
  {
private:
   int      AddFirst(CObject *aNewNode);     //    
   int      Insert(CObject *aNewNode);       //    

public:
                        CQueue(void) {}
                       ~CQueue(void) {}
   template<typename T>
   T                    Back(T);                //     
   template<typename T>
   T                    Front(T);               //     
   template<typename T>
   bool                 Push(T aValue);         //     
   void                 Pop(void);              //     
   int                  Size(void) const;       //    
   bool                 Empty(void) const;      //     
  };
//--------------------------------------------------------------------------------------------+
/*!
       
   \param   T aValue - 
   \return     
   \remark      T null, .  .
              ,   
*/
template<typename T>
T CQueue::Back(T null) {
   T _value;
   if(m_data_total - 1 < 0)
      return _value;

   CValContType *_pvct = GetFirstNode();
   _value = _pvct.GetData(null);
//---
   return _value;
}
/*!
       
   \param   T aValue - 
   \return     
   \remark      T null, .  .
              ,   
*/
template<typename T>
T CQueue::Front(T null) {
   T _value;
   if(m_data_total - 1 < 0)
      return _value;

   CValContType *_pvct = GetLastNode();
   CValContType *_pvct1 = GetNodeAtIndex(0);
   CValContType *_pvct2 = GetNodeAtIndex(1);
   CValContType *_pvct3 = GetNodeAtIndex(2);
   CValContType *_pvct4 = GetNodeAtIndex(3);
   _value = _pvct.GetData(null);
//---
   return _value;
}
/*!
       
   \param   T &aValue - 
   \return  true    ,  false
*/
template<typename T>
bool CQueue::Push(T aValue) {
   CValContType *_pvct = new CValContType(aValue);

   if(Insert((CValContType *)_pvct) == -1)
      return false;
//---
   return true;
}
/*!
       
*/
void CQueue::Pop(void) {
   if(m_data_total - 1 < 0)
      return;

   Delete(m_data_total - 1);
}
/*!
      
   \return     
*/
int CQueue::Size(void) const { return m_data_total; }
/*!
       
   \return  true   ,  false
*/
bool CQueue::Empty(void) const {
   if(m_data_total - 1 < 0)
      return true;
//---
   return false;
}
//--------------------------------------------------------------------------------------------+
/*!
      
   \param   CObject *aNewNode -    
   \return        ,  -1
*/
int CQueue::AddFirst(CObject *aNewNode) {
   if(!CheckPointer(aNewNode))
      return -1;

   if(m_first_node == NULL)
      m_first_node = aNewNode;
   else {
      m_first_node.Prev(aNewNode);
      aNewNode.Next(m_first_node);
   }
   m_curr_node = aNewNode;
   m_curr_idx = m_data_total;
   m_first_node = aNewNode;
   m_data_sort = false;
//---
   return m_data_total++;
}
/*!
      
   \param   CObject *aNewNode -    
   \return        ,  -1
*/
int CQueue::Insert(CObject *aNewNode) {
   if(!CheckPointer(aNewNode))
      return -1;

   if(GetNodeAtIndex(0) == NULL)
      return Add(aNewNode);
   else
      return AddFirst(aNewNode);
}
//+----------------------------------------------------------------------------+
