//+----------------------------------------------------------------------------+
//| xxxxxxxxxxxxxxxxxxxxxx Standard Class Library xxxxxxxxxxxxxxxxxxxxxxxxxxxx |
//| xxxxxxxxxxxxxxx Konstantin Karpov | coder-ex@yandex.ru xxxxxxxxxxxxxxxxxxx |
//+----------------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

#include <Arrays\List.mqh>
#include <SCL\v4.03\Container\ValType.mqh>

//+----------------------------------------------------------------------------+
/*!
   \brief      ,      -  ,
            FILO   ( ,  ).

   \details        .

   \details   Top   ,      
             ,  GetData  CValContType.       
             ,      .
*/
class CStack : private CList
  {
private:
   int         AddFirst(CObject *aNewNode);  //    
   int         Insert(CObject *aNewNode);    //    

public:
                        CStack(void) {}
                       ~CStack(void) {}
   template<typename T>
   T                    Top(T);                 //    ,   
   template<typename T>
   bool                 Push(T aValue);         //      
   void                 Pop(void);              //   
   int                  Size(void) const;       //    
   bool                 Empty(void) const;      //     
  };
//--------------------------------------------------------------------------------------------+
/*!
      
   \param   T aValue - 
   \return     
   \remark      T null, .  .
               ,   .
*/
template<typename T>
T CStack::Top(T null) {
   T _value;
   if(m_data_total - 1 < 0)
      return _value;

   CValContType *_pvct = GetFirstNode();
   _value = _pvct.GetData(null);
//---
   return _value;
}
/*!
        
   \param   T &aValue - 
   \return  true    ,  false
*/
template<typename T>
bool CStack::Push(T aValue) {
   CValContType *_pvct = new CValContType(aValue);

   if(Insert((CValContType *)_pvct) == -1)
      return false;
//---
   return true;
}
/*!
     
*/
void CStack::Pop(void) {
   if(m_data_total - 1 < 0)
      return;

   Delete(0);
}
/*!
      
   \return   
*/
int CStack::Size(void) const { return m_data_total; }
/*!
       
   \return  true  ,  false
*/
bool CStack::Empty(void) const {
   if(m_data_total - 1 < 0)
      return true;
//---
   return false;
}
//--------------------------------------------------------------------------------------------+
/*!
      
   \param   CObject *aNewNode -    
   \return        ,  -1
*/
int CStack::AddFirst(CObject *aNewNode) {
   if(!CheckPointer(aNewNode))
      return -1;

   if(m_first_node == NULL)
      m_first_node = aNewNode;
   else {
      m_first_node.Prev(aNewNode);
      aNewNode.Next(m_first_node);
   }
   m_curr_node = aNewNode;
   m_curr_idx = m_data_total;
   m_first_node = aNewNode;
   m_data_sort = false;
//---
   return m_data_total++;
}
/*!
      
   \param   CObject *aNewNode -    
   \return        ,  -1
*/
int CStack::Insert(CObject *aNewNode) {
   if(!CheckPointer(aNewNode))
      return -1;

   if(GetNodeAtIndex(0) == NULL)
      return Add(aNewNode);
   else
      return AddFirst(aNewNode);
}
//+----------------------------------------------------------------------------+
