//+----------------------------------------------------------------------------+
//| xxxxxxxxxxxxxxxxxxxxxx Standard Class Library xxxxxxxxxxxxxxxxxxxxxxxxxxxx |
//| xxxxxxxxxxxxxxx Konstantin Karpov | coder-ex@yandex.ru xxxxxxxxxxxxxxxxxxx |
//+----------------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict

#include <Object.mqh>

//+----------------------------------------------------------------------------+
/*!
   \brief         
*/
class CValContType : public CObject
  {
private:
   long     m_l;     //  char, short, int, color, long
   ulong    m_u;     //  uchar, ushort, uint, ulong, datetime
   double   m_d;     //  float, double
   string   m_s;     //  string
   int      m_iType; //  

public:
   template<typename T>
                     CValContType(T aData);
                    ~CValContType(void);
   int               GetType(void);          //   
   template<typename C>
   C                 GetData(C );            //     
  };
//+------------------------------------------------------------------+
/*!
   
   \param   T aData -     T
*/
template<typename T>
CValContType::CValContType(T aData) {
   if(typename(aData) == "string") {
      m_s = (string)aData;
      m_iType = TYPE_STRING;
   } else if(typename(aData) == "double") {
      m_d = (double)aData;
      m_iType = TYPE_DOUBLE;
   } else if(typename(aData) == "float") {
      m_d = (float)aData;
      m_iType = TYPE_FLOAT;
   } else if(typename(aData) == "ulong") {
      m_u = (ulong)aData;
      m_iType = TYPE_ULONG;
   } else if(typename(aData) == "long") {
      m_l = (long)aData;
      m_iType = TYPE_LONG;
   } else if(typename(aData) == "uint") {
      m_u = (uint)aData;
      m_iType = TYPE_UINT;
   } else if(typename(aData) == "int") {
      m_l = (int)aData;
      m_iType = TYPE_INT;
   } else if(typename(aData) == "ushort") {
      m_u = (ushort)aData;
      m_iType = TYPE_USHORT;
   } else if(typename(aData) == "short") {
      m_l = (short)aData;
      m_iType = TYPE_SHORT;
   } else if(typename(aData) == "uchar") {
      m_u = (uchar)aData;
      m_iType = TYPE_UCHAR;
   } else if(typename(aData) == "char") {
      m_l = (char)aData;
      m_iType = TYPE_CHAR;
   } else if(typename(aData) == "datetime") {
      m_u = (datetime)aData;
      m_iType = TYPE_DATETIME;
   } else if(typename(aData) == "color") {
      m_l = (color)aData;
      m_iType = TYPE_COLOR;
   } 
}
/*!
   
*/
CValContType::~CValContType(void) { }
/*!
     
   \return      
*/
int CValContType::GetType(void) { return m_iType; }
/*!
       
   \param   C - 
   \return   
*/
template<typename C>
C CValContType::GetData(C ) {
   C _val;
   if(m_iType == TYPE_STRING)
      return (string)m_s;
//---
   return _val = (m_iType == TYPE_CHAR) ? (char)m_l :
                 (m_iType == TYPE_UCHAR) ? (uchar)m_u :
                 (m_iType == TYPE_SHORT) ? (short)m_l :
                 (m_iType == TYPE_USHORT) ? (ushort)m_u :
                 (m_iType == TYPE_INT) ? (int)m_l :
                 (m_iType == TYPE_UINT) ? (uint)m_u :
                 (m_iType == TYPE_COLOR) ? (color)m_l :
                 (m_iType == TYPE_LONG) ? (long)m_l :
                 (m_iType == TYPE_ULONG) ? (ulong)m_u :
                 (m_iType == TYPE_DATETIME) ? (datetime)m_u :
                 (m_iType == TYPE_FLOAT) ? (float)m_d :
                 (m_iType == TYPE_DOUBLE) ? (double)m_d : 0;
}
//+----------------------------------------------------------------------------+